#pragma once

#include "../../ecs_entity.h"

#define COMPONENT_COUNTER_MAX INT_MAX

typedef struct ComponentCounter
{
	ECSComponent component;
	s32 value;
	s32 max;
	s32 min;
} ComponentCounter;

void component_counter_init(ComponentCounter* self, ECS* ecs, s32 value, s32 max);
void component_counter_add(ComponentCounter* self, ECS* ecs);
void component_counter_tick(ComponentCounter* self, ECS* ecs);

static const ECSComponentInfo COMPONENT_COUNTER_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			(ECSFunction)component_counter_add,
			NULL,
			(ECSFunction)component_counter_tick,
			NULL,
			NULL,
		}
	},
	.type = ECS_COMPONENT_COUNTER,
	.size = sizeof(ComponentCounter)
};
