#pragma once

#include "../../entity/visual/entity_sprite.h"

#include "component_texture_quad.h"

#define COMPONENT_OUTLINE_SIZE 8
#define COMPONENT_OUTLINE_Z_OFFSET 0.001

static const vec4 COMPONENT_OUTLINE_COLOR = {1.0f, 1.0f, 1.0f, 1.0f};

typedef struct ComponentOutline
{
	ECSComponent component;
	vec4 color;
	f32 size;
	EntityID spriteID;
	bool isSpriteInit;
} ComponentOutline;

void component_outline_init(ComponentOutline* self, ECS* ecs, vec4 color, f32 size);
void component_outline_tick(ComponentOutline* self, ECS* ecs);
void component_outline_add(ComponentOutline* self, ECS* ecs);

static const ECSComponentInfo COMPONENT_OUTLINE_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			(ECSFunction)component_outline_add, 
			NULL,
			(ECSFunction)component_outline_tick, 
			NULL,
			NULL
		}
	},
	.type = ECS_COMPONENT_OUTLINE,
	.size = sizeof(ComponentOutline)
};
