#pragma once

#include "component/game/component_game_object.h"
#include "component/physics/component_copy_mouse_position.h"
#include "component/physics/component_physics.h"
#include "component/utility/component_counter.h"
#include "component/utility/component_timer.h"
#include "component/visual/component_atlas.h"
#include "component/visual/component_outline.h"
#include "component/visual/component_texture_quad.h"
#include "component/visual/component_text.h"

#include "../input/input.h"
#include "../../engine/renderer.h"
#include "../resource/resource_font.h"
#include "../resource/resource_music.h"
#include "../resource/resource_sound.h"

static const struct ECSComponentInfo ECS_COMPONENT_INFO[ECS_COMPONENT_COUNT] = 
{
	COMPONENT_GAME_OBJECT_INFO,
	COMPONENT_COUNTER_INFO,
	COMPONENT_TIMER_INFO,
	COMPONENT_TEXTURE_QUAD_INFO,
	COMPONENT_TEXT_INFO,
	COMPONENT_OUTLINE_INFO,
	COMPONENT_ATLAS_INFO,
	COMPONENT_PHYSICS_INFO,
	COMPONENT_COPY_MOUSE_POSITION_INFO
};

void ecs_tick(ECS* self);
void ecs_update(ECS* self);
void ecs_draw(ECS* self);
void ecs_init(ECS* self, Renderer* renderer, Input* input, Resources* resources, Postprocessing* postprocessing);
void ecs_clear(ECS* self);
void ecs_free(ECS* self);
