#include "entity_sprite.h"

EntityID
entity_sprite_add(ECS* ecs, Texture* texture, RendererBuffer buffer, const vec2 size, const vec3 position)
{
	EntityID id;

	id = ecs_entity_add(ecs);

	ecs_components_add(ecs, ENTITY_SPRITE_DEPENDENCIES, ENTITY_SPRITE_DEPENDENCY_COUNT, id);
	
	component_texture_quad_init
	(
		ecs_component_get(ecs, ECS_COMPONENT_TEXTURE_QUAD, id), 
		ecs, 
		texture, 
		&ecs->resources->shaders[SHADER_TEXTURE_QUAD],
		COMPONENT_TEXTURE_QUAD_FLIP_DEFAULT,
		COMPONENT_TEXTURE_QUAD_ORIGIN_DEFAULT,
		buffer,
		COMPONENT_TEXTURE_QUAD_ROTATION_DEFAULT,
		(f32*)size, 
		(f32*)COMPONENT_TEXTURE_QUAD_SCALE_DEFAULT,
		(f32*)COMPONENT_TEXTURE_QUAD_UV_MIN_DEFAULT,
		(f32*)COMPONENT_TEXTURE_QUAD_UV_MAX_DEFAULT,
		(f32*)COMPONENT_TEXTURE_QUAD_OFFSET_DEFAULT,
		(f32*)position,
		(f32*)COMPONENT_TEXTURE_QUAD_COLOR_DEFAULT
	);

	return id;
}
