#include "entity_text.h"

EntityID
entity_text_add
(
	ECS* ecs, 
	Font* font, 
	RendererBuffer buffer, 
	const char* string, 
	const vec3 position,
	const vec4 color,
	u32 length,
	u32 wrap
)
{
	EntityID id;

	id = ecs_entity_add(ecs);

	ecs_components_add(ecs, ENTITY_TEXT_DEPENDENCIES, ENTITY_TEXT_DEPENDENCY_COUNT, id);
	
	component_text_init
	(
		ecs_component_get(ecs, ECS_COMPONENT_TEXT, id), 
		ecs, 
		font,
		&ecs->resources->shaders[SHADER_TEXTURE_QUAD],
		buffer,
		string,
		(f32*)ENTITY_TEXT_SCALE_DEFAULT,
		position,
		(f32*)ENTITY_TEXT_OFFSET_DEFAULT,
		color,
		length,
		wrap
	);

	return id;
}
