#include "buffer.h"

void
buffer_draw(Renderer* renderer, Shader* shader, Postprocessing* postprocessing, RendererBuffer buffer)
{
	mat4 model;
	vec2 size;
	vec3 position;

	glm_vec2_zero(size);
	glm_vec3_zero(position);
	glm_mat4_identity(model);

	size[0] = renderer->size[0];
	size[1] = renderer->size[1];

	glm_translate(model, position);

	renderer_shader_use(renderer, shader);

	glDisable(GL_DEPTH_TEST);

	/*
	postprocessing->color[0] = 0.9f;
	postprocessing->color[1] = 0.25f;
	postprocessing->color[2] = 0.25f;
	postprocessing->color[3] = 1.0f;
	*/

	texture_quad_draw
	(
	 	&renderer->fboTextures[buffer],
		renderer,
		shader,
		(f32*)TEXTURE_QUAD_UV_MIN_DEFAULT,
		(f32*)TEXTURE_QUAD_UV_MAX_DEFAULT,
		model,
		size,
		postprocessing->color,
		FLIP_HORIZONTAL_VERTICAL
	);

	glEnable(GL_DEPTH_TEST);
}	
