#pragma once

#include "RENDER_COMMON.h"

#define TEXTURE_QUAD_UNIFORM_COLOR "color"
#define TEXTURE_QUAD_UNIFORM_MODEL "model"
#define TEXTURE_QUAD_UNIFORM_PROJECTION "projection"
#define TEXTURE_QUAD_UNIFORM_SIZE "size"
#define TEXTURE_QUAD_UNIFORM_TEXTURE "tex"
#define TEXTURE_QUAD_UNIFORM_VIEW "view"

void texture_quad_draw
(
	Texture* texture,
	Renderer* renderer, 
	Shader* shader, 
	vec2 uvMin,
	vec2 uvMax,
	mat4 model, 
	vec2 size, 
	vec4 color, 
	Flip flip
); 

#define TEXTURE_QUAD_COLOR_DEFAULT (f32*)OPAQUE

static const vec2 TEXTURE_QUAD_UV_MIN_DEFAULT = {0.0f, 0.0f};
static const vec2 TEXTURE_QUAD_UV_MAX_DEFAULT = {1.0f, 1.0f};
static const Flip TEXTURE_QUAD_FLIP_DEFAULT = FLIP_NONE;
static const Origin TEXTURE_QUAD_ORIGIN_DEFAULT = ORIGIN_CENTER;
