#include "gameplay.h"

const vec2 TEST_SIZE = {128.0f, 128.0f};
const vec3 TEST_POSITION = {64.0f, 64.0f, 0.1f};
const vec3 TEXT_POSITION = {300.0f, 300.0f, 0.0f};

static void _gameplay_entity_init(Gameplay* self);

static void 
_gameplay_entity_init(Gameplay* self)
{
	entity_cursor_add(self->ecs);

	entity_text_add
	(
		self->ecs, 
		&self->ecs->resources->fonts[FONT_TEST], 
		RENDERER_BUFFER_UI, 
		"Gaming", 
		TEXT_POSITION,
		OPAQUE,
		strlen("Gaming"),
		0
	);
}

void
gameplay_init(Gameplay* self, ECS* ecs)
{
	memset(self, '\0', sizeof(Gameplay));

	self->ecs = ecs;

	_gameplay_entity_init(self);
}

void
gameplay_tick(Gameplay* self)
{

}
