#pragma once

#include "STATE_COMMON.h"

static const ShaderType* STATE_SHADERS[STATE_COUNT] =
{
	GAMEPLAY_SHADERS,
	TITLE_SHADERS
};

static const u32 STATE_SHADER_COUNT[STATE_COUNT] = 
{
	GAMEPLAY_SHADER_COUNT,
	TITLE_SHADER_COUNT
};

static const TextureType* STATE_TEXTURES[STATE_COUNT] =
{
	GAMEPLAY_TEXTURES,
	TITLE_TEXTURES
};

static const u32 STATE_TEXTURE_COUNT[STATE_COUNT] =
{
	GAMEPLAY_TEXTURE_COUNT,
	TITLE_TEXTURE_COUNT
};

static const FontType* STATE_FONTS[STATE_COUNT] =
{
	GAMEPLAY_FONTS,
	TITLE_FONTS
};

static const u32 STATE_FONT_COUNT[STATE_COUNT] =
{
	GAMEPLAY_FONT_COUNT,
	TITLE_FONT_COUNT
};

static const SoundType* STATE_SOUNDS[STATE_COUNT] =
{
	GAMEPLAY_SOUNDS,
	TITLE_SOUNDS
};

static const u32 STATE_SOUND_COUNT[STATE_COUNT] =
{
	GAMEPLAY_SOUND_COUNT,
	TITLE_SOUND_COUNT
};

static const MusicType* STATE_MUSIC[STATE_COUNT] =
{
	GAMEPLAY_MUSIC,
	TITLE_MUSIC
};

static const u32 STATE_MUSIC_COUNT[STATE_COUNT] =
{
	GAMEPLAY_MUSIC_COUNT,
	TITLE_MUSIC_COUNT
};

void state_change(State* self, StateType type);
void state_init(State* self, ECS* ecs, StateType type);
void state_free(State* self);
void state_tick(State* self);
